-- =============================================================================
-- Descrio  : Rotina para calcular o tempo de preparo do vo.
-- EXECUTE CALC_TEMPOPREP_VOO('0001','000000000999','0028','32900001')
-- =============================================================================
CREATE OR REPLACE PROCEDURE CALC_TEMPOPREP_VOO(
P_CDFILIAL    FILIAL  .CDFILIAL  %TYPE,
P_CDOPERADOR  OPERADOR.CDOPERADOR%TYPE,
P_CDCIA       VARCHAR2,
P_CDVOOTRECHO VARCHAR2
) AS
V_QTHRPREPREC  ETAFABRIC.QTHRETFABRIC%TYPE;
V_QTHRPREPSUB  ETAFABRIC.QTHRETFABRIC%TYPE;
V_QTHRPREPSER  ETAFABRIC.QTHRETFABRIC%TYPE;
V_QTHRMAIORREC ETAFABRIC.QTHRETFABRIC%TYPE;
V_QTHRMAIORSUB ETAFABRIC.QTHRETFABRIC%TYPE;
V_QTHRMAIORSER ETAFABRIC.QTHRETFABRIC%TYPE;
V_QTSERVICO    SERVPLANO.QTSERFATSP  %TYPE;
V_CDMANCIA     MANUALCIA.CDMANCIA    %TYPE;
V_RETORNA_CDCICLO CICLO.CDCICLO%TYPE;
BEGIN
	INSERT INTO TEMPOPREPVOO
   (CDFILIAL,DTHRGERTEMP,CDOPERADOR)
   VALUES
   (P_CDFILIAL,SYSDATE,P_CDOPERADOR);

	/* Apaga o clculo do tempo de preparo da receita  */
   DELETE FROM TEMPOPREPREC
   WHERE CDFILIAL = P_CDFILIAL;
	/* Apaga o clculo do tempo de preparo do sub-grupo  */
   DELETE FROM TEMPOPREPSUB
   WHERE CDFILIAL = P_CDFILIAL;
	/* Apaga o clculo do tempo de preparo do servio  */
   DELETE FROM TEMPOPREPSER
   WHERE CDFILIAL = P_CDFILIAL;
	/* Apaga o clculo do tempo de preparo do vo  */
	UPDATE VOOTRECHO
	SET QTHRPREPVOO = NULL
   WHERE (CDFILIAL = P_CDFILIAL);

	/* Clculo das horas de produo dos vos */
   FOR C_VOO IN (SELECT VT.CDCIA,VT.NRVOO,VT.CDTRECHO,VT.CDBASEORI,VT.CDBASEDES,VT.HRDECOLVOO,
                        VT.HRPOUSOVOO,VT.IDTIPAJUSFAT,VT.IDSITVOOTRE,VT.DTULTATUTREC,CF.CDCICLO AS CDCICUNICO
                 FROM VOOTRECHO VT, CIAFILI CF
                 WHERE (VT.CDFILIAL = P_CDFILIAL) AND
                       (CF.CDFILIAL = P_CDFILIAL) AND
                       (CF.CDCIA    = VT.CDCIA  ) AND
                       (INSTR(NVL(P_CDCIA,CF.CDCIA),CF.CDCIA)>0) AND
                       (INSTR(NVL(P_CDVOOTRECHO,VT.NRVOO||VT.CDTRECHO),VT.NRVOO||VT.CDTRECHO)>0)) LOOP

     	V_QTHRMAIORSER := 0;

      SELECT MAX(CDMANCIA)
      INTO V_CDMANCIA
      FROM MANUALCIA
      WHERE (CDFILIAL   = P_CDFILIAL ) AND
            (CDCIA      = C_VOO.CDCIA) AND
            (IDTPMANUAL = 'M'        ) AND
            (DTINIVGMA  = (SELECT MAX(DTINIVGMA)
                           FROM MANUALCIA
                           WHERE (CDFILIAL   = P_CDFILIAL    ) AND
                                 (CDCIA      = C_VOO.CDCIA   ) AND
                                 (IDTPMANUAL = 'M'           ) AND
                                 (DTINIVGMA <= TRUNC(SYSDATE))));

   	/* Clculo das horas de produo dos servios */
      /*FOR C_SER IN(SELECT PA.CDSERVICO,SM.CDCLASSE,SM.CDCICLO
                   FROM PAD_VOOPREFEQUI PA, SERVMANUAL SM
                   WHERE (PA.CDFILIAL     = P_CDFILIAL    ) AND
                         (PA.CDCIA        = C_VOO.CDCIA   ) AND
                         (PA.NRVOO        = C_VOO.NRVOO   ) AND
                         (PA.CDTRECHO     = C_VOO.CDTRECHO) AND
                         (PA.IDSITSERVICO = '1'           ) AND
                         (SM.CDFILIAL     = PA.CDFILIAL   ) AND
                         (SM.CDCIA        = PA.CDCIA      ) AND
                         (SM.CDMANCIA     = V_CDMANCIA    ) AND
                         (SM.CDSERVICO    = PA.CDSERVICO  )) LOOP*/
      FOR C_SER IN(SELECT PA.CDSERVICO,PR.CDCLASSE,PR.CDCICLO
                   FROM PAD_VOOPREFEQUI PA, ESPEPROD EP, PRODUTO PR
                   WHERE (PA.CDFILIAL     = P_CDFILIAL    ) AND
                         (PA.CDCIA        = C_VOO.CDCIA   ) AND
                         (PA.NRVOO        = C_VOO.NRVOO   ) AND
                         (PA.CDTRECHO     = C_VOO.CDTRECHO) AND
                         (PA.IDSITSERVICO = '1'           ) AND
                         (EP.IDTPMANUAL   = 'M'           ) AND
                         (EP.CDFILIAL     = PA.CDFILIAL   ) AND
                         (EP.CDCIA        = PA.CDCIA      ) AND
                         (EP.CDMANCIA     = V_CDMANCIA    ) AND
                         (EP.CDPRODUTO    = PA.CDSERVICO  ) AND
                         (PR.CDPRODUTO    = EP.CDPRODUTO  ) AND
                         (PR.IDPRODCOMISS = '1'           )) LOOP

	       	IF (C_SER.CDCICLO <> C_VOO.CDCICUNICO) THEN
         	  V_RETORNA_CDCICLO := C_SER.CDCICLO;
            RETORNA_CICLO(P_CDFILIAL,C_VOO.CDCIA,C_VOO.NRVOO,C_VOO.CDTRECHO,TRUNC(SYSDATE),
                          C_SER.CDSERVICO,C_SER.CDCLASSE,V_RETORNA_CDCICLO);
         ELSE
         	  V_RETORNA_CDCICLO := C_SER.CDCICLO;
         END IF;

         IF (C_SER.CDCICLO = V_RETORNA_CDCICLO) THEN
            /* Verifica se j foi calculado o tempo de preparo para o servio. */
            SELECT MAX(QTHRPREPSER)
            INTO V_QTHRMAIORSUB
            FROM TEMPOPREPSER
            WHERE (CDFILIAL  = P_CDFILIAL     ) AND
                  (CDSERVICO = C_SER.CDSERVICO);

            IF V_QTHRMAIORSUB IS NULL THEN
               V_QTHRMAIORSUB := 0;
               /* Clculo das horas de produo dos sub-grupos */
               /*FOR C_SUB IN(SELECT CDSUBGRU
                            FROM SUBGRUSEMA
                            WHERE (CDFILIAL  = P_CDFILIAL     ) AND
                                  (CDCIA     = C_VOO.CDCIA    ) AND
                                  (CDMANCIA  = V_CDMANCIA     ) AND
                                  (CDSERVICO = C_SER.CDSERVICO)) LOOP*/
               FOR C_SUB IN(SELECT CP.CDPRODINSUMO AS CDSUBGRU
                            FROM ESPEPROD EP, COMPPROD CP, PRODUTO PR
                            WHERE (EP.IDTPMANUAL   = 'M'            ) AND
                                  (EP.CDFILIAL     = P_CDFILIAL     ) AND
                                  (EP.CDCIA        = C_VOO.CDCIA    ) AND
                                  (EP.CDMANCIA     = V_CDMANCIA     ) AND
                                  (EP.CDPRODUTO    = C_SER.CDSERVICO) AND
                                  (CP.CDPRODUTO    = EP.CDPRODUTO   ) AND
                                  (CP.CDESPEPROD   = EP.CDESPEPROD  ) AND
                                  (PR.CDPRODUTO    = CP.CDPRODINSUMO) AND
                                  (PR.IDPRODCOMISS = '2'            )) LOOP

                  V_QTHRMAIORREC := 0;
                  /* Clculo das horas de produo das receitas */
                  /*FOR C_REC IN(SELECT CDRECEITA,QTRECSUMA
                               FROM RECSUBSEMA
                               WHERE (CDFILIAL  = P_CDFILIAL     ) AND
                                     (CDCIA     = C_VOO.CDCIA    ) AND
                                     (CDMANCIA  = V_CDMANCIA     ) AND
                                     (CDSERVICO = C_SER.CDSERVICO) AND
                                     (CDSUBGRU  = C_SUB.CDSUBGRU )) LOOP*/
                  FOR C_REC IN(SELECT CP.CDPRODINSUMO AS CDRECEITA,
                                      CP.QTINSUMO     AS QTRECSUMA
                               FROM ESPEPROD EP, COMPPROD CP, PRODUTO PR
                               WHERE (EP.IDTPMANUAL   = 'M'            ) AND
                                     (EP.CDFILIAL     = P_CDFILIAL     ) AND
                                     (EP.CDCIA        = C_VOO.CDCIA    ) AND
                                     (EP.CDMANCIA     = V_CDMANCIA     ) AND
                                     (EP.CDPRODUTO    = C_SER.CDSERVICO) AND
                                     (CP.CDPRODUTO    = C_SUB.CDSUBGRU ) AND
                                     (CP.CDPRODUTOAUX = EP.CDPRODUTO   ) AND
                                     (CP.CDESPPRODAUX = EP.CDESPEPROD  ) AND
                                     (PR.CDPRODUTO    = CP.CDPRODINSUMO) AND
                                     (PR.IDPRODCOMISS = '3'            )) LOOP

                     /* Calcula o tempo para preparar a composio da receita*/
                     CALC_TEMPOPREP_REC(P_CDFILIAL,C_REC.CDRECEITA,V_QTHRPREPREC);

                     /* Soma o tempo de preparo da composio da receita com o tempo da receita */
                     SELECT NVL(SUM(TE.QTHRETFABRPR),0)+V_QTHRPREPREC
                     INTO V_QTHRPREPREC
                     FROM TEMPOETAFABR TE, PROCFABRICA PF
                     WHERE (PF.CDFILIAL     = P_CDFILIAL     ) AND
                           (PF.CDPRODUTO    = C_REC.CDRECEITA) AND
                           (PF.IDPROFABPADR = 'S'            ) AND
                           (TE.CDFILIAL     = PF.CDFILIAL    ) AND
                           (TE.CDPRODUTO    = PF.CDPRODUTO   ) AND
                           (TE.CDPROCFABRIC = PF.CDPROCFABRIC) AND
                           (C_REC.QTRECSUMA BETWEEN TE.VRINIQTFABPR AND TE.VRFINQTFABPR);

                     IF V_QTHRMAIORREC  < V_QTHRPREPREC THEN
                        V_QTHRMAIORREC := V_QTHRPREPREC;
                     END IF;

                  END LOOP;
                  /*****/

                  INSERT INTO TEMPOPREPSUB
                  (CDFILIAL,CDSERVICO,CDSUBGRU,QTHRPREPSUB)
                  VALUES
                  (P_CDFILIAL,C_SER.CDSERVICO,C_SUB.CDSUBGRU,V_QTHRMAIORREC);

                  SELECT NVL(SUM(TE.QTHRETFABRPR),0)+V_QTHRMAIORREC
                  INTO V_QTHRPREPSUB
                  FROM TEMPOETAFABR TE, PROCFABRICA PF
                  WHERE (PF.CDFILIAL     = P_CDFILIAL     ) AND
                        (PF.CDPRODUTO    = C_SER.CDSERVICO) AND
                        (PF.IDPROFABPADR = 'S'            ) AND
                        (TE.CDFILIAL     = PF.CDFILIAL    ) AND
                        (TE.CDPRODUTO    = PF.CDPRODUTO   ) AND
                        (TE.CDPROCFABRIC = PF.CDPROCFABRIC) AND
                        (1 BETWEEN TE.VRINIQTFABPR AND TE.VRFINQTFABPR);

                  IF V_QTHRMAIORSUB  < V_QTHRPREPSUB THEN
                     V_QTHRMAIORSUB := V_QTHRPREPSUB;
                  END IF;

               END LOOP;
               /*****/

               INSERT INTO TEMPOPREPSER
               (CDFILIAL,CDSERVICO,QTHRPREPSER)
               VALUES
               (P_CDFILIAL,C_SER.CDSERVICO,V_QTHRMAIORSUB);

            END IF;

            /* Mdia geral da quantidade de servio do dia da semana */
            SELECT NVL(ROUND(SUM(QTSERFATSP)/COUNT(*)),1)
            INTO V_QTSERVICO
            FROM (SELECT DTHRPLAVOOPV,SUM(QTSERFATSP) QTSERFATSP
                  FROM SERVPLANO
                  WHERE (CDFILIAL  = P_CDFILIAL     ) AND
                        (CDCIA     = C_VOO.CDCIA    ) AND
                        (NRVOO     = C_VOO.NRVOO    ) AND
                        (CDTRECHO  = C_VOO.CDTRECHO ) AND
                        (CDSERVICO = C_SER.CDSERVICO)
                  GROUP BY DTHRPLAVOOPV);

            SELECT NVL(SUM(TE.QTHRETFABRPR),0)+V_QTHRMAIORSUB
            INTO V_QTHRPREPSER
            FROM TEMPOETAFABR TE, PROCFABRICA PF
            WHERE (PF.CDFILIAL     = P_CDFILIAL     ) AND
                  (PF.CDPRODUTO    = C_SER.CDSERVICO) AND
                  (PF.IDPROFABPADR = 'S'            ) AND
                  (TE.CDFILIAL     = PF.CDFILIAL    ) AND
                  (TE.CDPRODUTO    = PF.CDPRODUTO   ) AND
                  (TE.CDPROCFABRIC = PF.CDPROCFABRIC) AND
                  (V_QTSERVICO BETWEEN TE.VRINIQTFABPR AND TE.VRFINQTFABPR);

            IF V_QTHRMAIORSER  < V_QTHRPREPSER THEN
               V_QTHRMAIORSER := V_QTHRPREPSER;
            END IF;
   		    END IF;
      END LOOP;
      /*****/

      UPDATE VOOTRECHO
      SET QTHRPREPVOO = V_QTHRMAIORSER
      WHERE (CDFILIAL = P_CDFILIAL    ) AND
            (CDCIA    = C_VOO.CDCIA   ) AND
            (NRVOO    = C_VOO.NRVOO   ) AND
            (CDTRECHO = C_VOO.CDTRECHO);

   END LOOP;
   /*****/
END;
/

